using System;
					
public class Program
{
	public static void Main()
	{
		string t = Console.ReadLine();
		char[] znakovi = t.ToCharArray();
		int broj = znakovi.Length /2;
		int i = 0;
		int pg = -1;
		int dg = -1;
		while (i < broj)
		{
			if (znakovi[i]== znakovi[znakovi.Length - (i+1)])
			{
				i++;
			}
			else
			{
				pg = i;
				break;
			}
		}
		i++;
		while (i < broj)
		{
			if (znakovi[i]== znakovi[znakovi.Length - (i+1)])
			{
				i++;
			}
			else
			{
				dg = i;
				break;
			}
		}
		int s = 0;
		
		if (pg < 0 && dg < 0)
		{
			Console.WriteLine(1);
		}
		else if (znakovi.Length % 2 == 0)
		{
			if (pg > -1 && dg == -1)
			{
				s++;
			}
			else if (pg > -1 && dg == pg)
			{
				s++;
			}
			else
			{
				Console.WriteLine(znakovi.Length-1-pg-dg);
			}
		}
		else
		{
			if (pg > -1 && dg == -1)
			{
				Console.WriteLine(znakovi.Length-pg-broj);
			}
			else if (pg > -1 && dg == pg)
			{
				s++;
			}
			else
			{
				Console.WriteLine(znakovi.Length-pg-dg);
			}
		}

	}
}